clc;
clear all;
debug = 0;
lengthX = 18000;

names = { 'lazy',  'haar', 'db1', 'db2', 'db3', 'db4', 'db5', 'db6', 'db7',...
    'db8', 'sym2', 'sym3', 'sym4', 'sym5', 'sym6', 'sym7', 'sym8', 'cdf1.1',...
    'cdf1.3','cdf1.5' , 'cdf2.2','cdf2.4','cdf2.6','cdf3.1','cdf3.3','cdf3.5',...
    'cdf4.2','cdf4.4','cdf4.6','cdf5.1','cdf5.3','cdf5.5' , 'cdf6.2','cdf6.4',...
    'cdf6.6', 'bior4.4' ,'bior5.5' };

names3 = {'7_9','4_2','5_3'};




 for name =1:length(names) + length(names3)
%for name = 1:1

    
if name <= length(names)
    disp(names{name});
    ls = liftWave(names{name});
else
    nameIdx = name - length(names);
    disp(names3{nameIdx});
    ls = getLSformPeyre(names3{nameIdx});
end

%ls = liftWave('cdf1.3');
%dispLsMore(ls);
%ls = separateSteps(ls,[1 2 3]);
%dispLsMore(ls);
%ls = getLSformPeyre(names{name});
%ls = getLSformPeyre('4_2');

%ls = liftWave('db2');

%dispLsMore(ls);

x = randn(1,lengthX)+2;

% for level = 1:6
for level = 1:10

for it = 0:-1:-2^level-1
%for it = 1:1   
[Xtemp] = mylwt(x,ls,level);
[x_hat_orig] = myilwt(Xtemp,ls,level);
Xlift = lift2cell(Xtemp,level);

[leftSude,rightLiche] = extensions(ls,[0,1]);
[leftLiche,rightSude] = extensions(ls,[1,0]);

xHalf = ceil(length(x)/2) +it;
%xHalf = 132 +it;
% indexovn o 0 aby sud byly prvn
lastIndex = xHalf-1;
firstIndex = xHalf-1 +1;

x1 = x(1:xHalf);
x2 = x(xHalf+1:end);

%[left,right] = extensions(ls,[firstIndex,lastIndex]);
   [left,right,lefts,rights]=extJ(ls,firstIndex,level);
  % [L,R] = allExtensions( left, right, level );
   
   
   
%rightExt = rightLiche+rightLiche*(2^(level-1)-1);
%leftExt = leftSude+leftSude*(2^(level-1)-1);

extMove = 0* 2^(level);
rightExt = right + extMove;
leftExt = left - extMove;
% rightExt = right;
% leftExt = left;

 if debug ~= 0   
  disp(['lastInd=',num2str(lastIndex),...
        ' firstInd=',num2str(firstIndex),...
      ' leftExtension= ', num2str(leftExt), ' rightExtension= ', num2str(rightExt), ' sum= ', num2str(leftExt+rightExt) ]);

  for i =1:length(lefts)
       disp(sprintf('Prodloueni v %d urovni: leve %d, prave %d, sum=%d',i,lefts(i),rights(i),lefts(i)+rights(i)));
  end
 end
  
 if xHalf+rightExt > lengthX
     disp(sprintf('Prave prodlouzeni presahuje velikost signalu. Delka je %d, s prodlouzenim %d. Pokracuji...',lengthX,xHalf+rightExt));
     continue;
 end;
 
 if xHalf+1-leftExt < 1
     disp(sprintf('Leve prodlouzeni podteka %d. Pokracuji...',xHalf+1-leftExt));
     continue;
 end;
 
x1ext = x(1:xHalf+rightExt);
x2ext = x(xHalf+1-leftExt:end);


[A1] = mylwt(x1ext,ls,level);
Xlift1temp = lift2cell(A1,level);

% A1_hat = cell2lift(Xlift1temp,level);
% err_hat = sum( abs( A1_hat - A1') )

[A2] = mylwt(x2ext,ls,level,firstIndex-leftExt);
Xlift2temp = lift2cell(A2,level,firstIndex-leftExt);

% A2_hat = cell2lift(Xlift2temp,level,firstIndex-leftExt);
% err_hat = sum( abs( A2_hat - A2') )

Xlift1 = cropRight(Xlift1temp,right,lastIndex );
Xlift2 = cropLeft(Xlift2temp,left,firstIndex );

[left,right,lefts,rights]=extJinv(ls,firstIndex,level);


 if debug ~= 0   
  disp([' leftExtension= ', num2str(right), ' rightExtension= ', num2str(left), ' sum= ', num2str(left+right) ]);

  for i =1:length(lefts)
       disp(sprintf('Prodloueni v %d urovni: leve %d, prave %d, sum=%d',i,rights(i),lefts(i),lefts(i)+rights(i)));
  end
 end


inverseExt = left;
Xlift1temp = cell2lift(Xlift1,level)';
Xlift1temp = [Xlift1temp zeros(1,inverseExt)];
X1_hat = myilwt(Xlift1temp,ls,level);

inverseExt = right;
Xlift2temp = cell2lift(Xlift2,level,firstIndex)';
Xlift2temp = [zeros(1,inverseExt), Xlift2temp];
X2_hat = myilwt(Xlift2temp,ls,level,firstIndex-inverseExt);

 MSE = checkTransform(Xlift,[Xlift1,Xlift2]);

 if debug ~= 0  disp(['MSE ve wavelet. oblasti= ', num2str(MSE)]); end

plots = cell(level+1,1);

for j=1:level
    plots{j} = zeros(length(Xlift{j}),3);
    plots{j}(:,1) = Xlift{j}';
    plots{j}(1:length(Xlift1{j}),2) = Xlift1{j}';
    plots{j}(end-length(Xlift2{j})+1:end,3) = Xlift2{j}';
end

plots{level+1} = zeros(length(Xlift{level+1}),3);
plots{level+1}(:,1) = Xlift{level+1}';
plots{level+1}(1:length(Xlift1{level+1}),2) = Xlift1{level+1}';
plots{level+1}(end-length(Xlift2{level+1})+1:end,3) = Xlift2{level+1}';

  first = [X1_hat, zeros(1,length(x)-length(X1_hat)) ]';
  second = [zeros(1,length(x)-length(X2_hat)), X2_hat  ]';
  suma = first + second;
  MSE = sum(abs(x_hat_orig'-suma));

if debug ~= 0 
figure(1); 
clf;
for j = 1:level+1
    subplot(level+1,1,j);
    stem(plots{j}(:,1));
end
pause;
clf;
for j = 1:level+1
    subplot(level+1,1,j);
    stem(plots{j}(:,1:2));
end
pause;
clf;
for j = 1:level+1
    subplot(level+1,1,j);
    stem(plots{j}(:,[1,3]));
end
 pause;
  figure(2);
 clf;
  subplot(2,1,1);
osax = 0:length(x')-1;
    stem(osax,[x_hat_orig',suma]);
    subplot(2,1,2);
    stem(osax,[first,second]);
 end    
    
   

  if(MSE>10^-8)
     disp(['MSE po rekonstrukci= ', num2str(MSE)]); 

end
 
 end;
end;
 
%  figure(2);
%  clf;
%   subplot(2,1,1);
%     stem([Xlift1temp{1}, zeros(1,length(Xlift{1})-length(Xlift1temp{1}) )]);
%     subplot(2,1,2);
%     stem([zeros(1,length(Xlift{1})-length(Xlift2temp{1}) ), Xlift2temp{1}]);

    
 

end
